;CodeVisionAVR C Compiler V1.24.2c Evaluation
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 // Used C
;       2 #include <mega8535.h>
;       3 
;       4 // LCD Specific
;       5 #include "ks0108.h"
;       6 #include "font6x8.h"

	.CSEG
;       7 #include "pics.h"
;       8 //#include "font12x16.h"
;       9 #include <delay.h>
;      10 
;      11 void main(void) {          
_main:
;      12 	struct font smallFont, largeFont;
;      13 	unsigned char i,j;
;      14 	
;      15 	DDRB=0xFF;
	SBIW R28,8
;	smallFont -> Y+4
;	largeFont -> Y+0
;	i -> R16
;	j -> R17
	LDI  R30,LOW(255)
	OUT  0x17,R30
;      16 	PORTB=0xFF;
	RCALL SUBOPT_0x0
;      17 	
;      18 	DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
;      19 	PORTC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x15,R30
;      20 	
;      21 	delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x1
;      22 	          
;      23 	smallFont.width = FONT6X8_WIDTH;
	LDI  R30,LOW(6)
	STD  Y+4,R30
;      24 	smallFont.height = FONT6X8_HEIGHT;
	LDI  R30,LOW(8)
	STD  Y+5,R30
;      25 	smallFont.charData = Font6x8;
	LDI  R30,LOW(_Font6x8_G1*2)
	LDI  R31,HIGH(_Font6x8_G1*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
;      26 	//smallFont.width = FONT12X16_WIDTH;
;      27 	//smallFont.height = FONT12X16_HEIGHT;
;      28 	//smallFont.charData = Font12x16;
;      29 	
;      30 	ks0108Init();
	RCALL _ks0108Init
;      31 	
;      32 
;      33 
;      34    /*	PORTB=0x00;
;      35 		delay_ms(1000);
;      36 		PORTB=0xFF;
;      37 		delay_ms(1000);
;      38 
;      39 
;      40 	ks0108GotoXY(0,0);
;      41 	for(i=0;i<64;i++)
;      42 	{                     
;      43 	    ks0108SetDot(i,i);
;      44 	}                   
;      45 	for(i=64;i<128;i++)
;      46 	{
;      47 		ks0108SetDot(i,i-64);
;      48 	}
;      49 
;      50 
;      51 	PORTB=0x00;
;      52 		delay_ms(1000);
;      53 		PORTB=0xFF;
;      54 		delay_ms(1000); */
;      55                         
;      56 		
;      57     ks0108GotoXY(2,2);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x2
	RCALL _ks0108GotoXY
;      58     ks0108PutStringP("Teststring 0\n Testring 1\n Testring 2\n",smallFont);
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,6
	LDI  R26,4
	RCALL __PUTPARL
	RCALL _ks0108PutStringP
;      59     
;      60     while(PINC.0 == 1)
_0x3:
	SBIC 0x13,0
;      61     		;
	RJMP _0x3
;      62     
;      63     ks0108Picture(bsj);
	LDI  R30,LOW(_bsj_G1*2)
	LDI  R31,HIGH(_bsj_G1*2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ks0108Picture
;      64 		
;      65 	while(1)
_0x6:
;      66 	{  
;      67 	  	PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;      68 		delay_ms(200);
	RCALL SUBOPT_0x3
;      69 		PORTB=0xFF;
	RCALL SUBOPT_0x0
;      70 		delay_ms(200);
	RCALL SUBOPT_0x3
;      71 	}
	RJMP _0x6
;      72 }
	ADIW R28,8
_0x9:
	RJMP _0x9
;      73 // Used C
;      74 #include <mega8535.h>
;      75 
;      76 // LCD Specific
;      77 #include "ks0108.h"
;      78 
;      79 struct displayPos pos;

	.DSEG
_pos:
	.BYTE 0x3
;      80 unsigned char inverted=0;
;      81 
;      82 void ks0108Picture(flash unsigned char* pic)
;      83 {

	.CSEG
_ks0108Picture:
;      84 	unsigned int i,j;
;      85 		
;      86 	for(i=0;i<8;i++)
	RCALL __SAVELOCR4
;	*pic -> Y+4
;	i -> R16,R17
;	j -> R18,R19
	__GETWRN 16,17,0
_0xB:
	__CPWRN 16,17,8
	BRSH _0xC
;      87 	{
;      88 		ks0108GotoXY(0,i*8);
	RCALL SUBOPT_0x4
	__GETW1R 16,17
	RCALL __LSLW3
	RCALL SUBOPT_0x5
;      89 		for(j=0; j<128; j++)
	__GETWRN 18,19,0
_0xE:
	__CPWRN 18,19,128
	BRSH _0xF
;      90 			ks0108WriteData(pic[(i*128)+j]);
	__GETW1R 16,17
	RCALL __LSLW3
	RCALL __LSLW4
	ADD  R30,R18
	ADC  R31,R19
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	RCALL SUBOPT_0x6
	__ADDWRN 18,19,1
	RJMP _0xE
_0xF:
;      91 	}
	__ADDWRN 16,17,1
	RJMP _0xB
_0xC:
;      92 }
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
;      93 
;      94 void ks0108Enable(void) {
_ks0108Enable:
;      95 	volatile unsigned char i;
;      96 	
;      97 	LCD_CMD_PORT |= 0x01 << EN;						// EN high level width: min. 450ns
	SBIW R28,1
;	i -> Y+0
	SBI  0x12,2
;      98 	#asm
;      99 		nop
		nop
;     100 		nop
		nop
;     101 		nop
		nop
;     102 		nop
		nop
;     103 		nop
		nop
;     104 		nop
		nop
;     105 	#endasm

;     106 	LCD_CMD_PORT &= ~(0x01 << EN);
	CBI  0x12,2
;     107 	for(i=0; i<16; i++);								// a little delay loop (faster than reading the busy flag)
	LDI  R30,LOW(0)
	ST   Y,R30
_0x11:
	LD   R26,Y
	CPI  R26,LOW(0x10)
	BRSH _0x12
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RJMP _0x11
_0x12:
;     108 }
	ADIW R28,1
	RET
;     109 
;     110 void ks0108Fill(unsigned char mode) {
_ks0108Fill:
;     111 	unsigned char i, j;
;     112 	
;     113 	for(i=0; i<8; i++) {							// page address
	RCALL __SAVELOCR2
;	mode -> Y+2
;	i -> R16
;	j -> R17
	LDI  R16,LOW(0)
_0x14:
	CPI  R16,8
	BRSH _0x15
;     114 		ks0108GotoXY(0, i*8);
	RCALL SUBOPT_0x4
	MOV  R30,R16
	RCALL __LSLB3
	RCALL SUBOPT_0x5
;     115 		for(j=0; j<128; j++)						// x address
	LDI  R17,LOW(0)
_0x17:
	CPI  R17,128
	BRSH _0x18
;     116 			ks0108WriteData(mode);					// write data
	LDD  R30,Y+2
	RCALL SUBOPT_0x6
	SUBI R17,-1
	RJMP _0x17
_0x18:
;     117 	}
	SUBI R16,-1
	RJMP _0x14
_0x15:
;     118 }
	RCALL __LOADLOCR2
	ADIW R28,3
	RET
;     119 
;     120 void ks0108GotoXY(unsigned char x, unsigned char y) {
_ks0108GotoXY:
;     121 	unsigned char chip = CHIP1, cmd;
;     122 	
;     123 	if(x > 127) x = 0;								// ensure that coordinates are legal
	RCALL __SAVELOCR2
;	x -> Y+3
;	y -> Y+2
;	chip -> R16
;	cmd -> R17
	LDI  R16,0
	LDD  R26,Y+3
	LDI  R30,LOW(127)
	CP   R30,R26
	BRSH _0x19
	LDI  R30,LOW(0)
	STD  Y+3,R30
;     124 	if(y > 63)  y = 0;
_0x19:
	LDD  R26,Y+2
	LDI  R30,LOW(63)
	CP   R30,R26
	BRSH _0x1A
	LDI  R30,LOW(0)
	STD  Y+2,R30
;     125 	
;     126 	pos.x = x;										// save new coordinates
_0x1A:
	LDD  R30,Y+3
	STS  _pos,R30
;     127 	pos.y = y;
	LDD  R30,Y+2
	__PUTB1MN _pos,1
;     128 	pos.page = y/8;
	RCALL __LSRB3
	__PUTB1MN _pos,2
;     129 	
;     130 	if(x >= 64) {									// select the right chip
	LDD  R26,Y+3
	CPI  R26,LOW(0x40)
	BRLO _0x1B
;     131 		x -= 64;
	LDD  R30,Y+3
	SUBI R30,LOW(64)
	STD  Y+3,R30
;     132 		chip = CHIP2;
	LDI  R16,LOW(1)
;     133 	}
;     134 	cmd = LCD_SET_ADD | x;
_0x1B:
	LDD  R30,Y+3
	ORI  R30,0x40
	RCALL SUBOPT_0x7
;     135 	ks0108WriteCommand(cmd, chip);					// set x address on active chip
	ST   -Y,R16
	RCALL _ks0108WriteCommand
;     136 	
;     137 	cmd = LCD_SET_PAGE | pos.page;					// set y address on both chips
	__GETB1MN _pos,2
	ORI  R30,LOW(0xB8)
	RCALL SUBOPT_0x7
;     138 	ks0108WriteCommand(cmd, CHIP1);
	RCALL SUBOPT_0x4
	RCALL _ks0108WriteCommand
;     139 	ks0108WriteCommand(cmd, CHIP2);
	ST   -Y,R17
	RCALL SUBOPT_0x8
;     140 }
	RCALL __LOADLOCR2
	ADIW R28,4
	RET
;     141 
;     142 void ks0108Init(void) {
_ks0108Init:
;     143 	pos.x = 0;
	LDI  R30,LOW(0)
	STS  _pos,R30
;     144 	pos.y = 0;
	__PUTB1MN _pos,1
;     145 	pos.page = 0;
	__PUTB1MN _pos,2
;     146 	
;     147 	LCD_CMD_DIR = 0xFF;								// command port is output
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     148 	ks0108WriteCommand(LCD_ON, CHIP1);				// power on
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x4
	RCALL _ks0108WriteCommand
;     149 	ks0108WriteCommand(LCD_ON, CHIP2);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x8
;     150 	
;     151 	ks0108WriteCommand(LCD_DISP_START, CHIP1);		// display start line = 0
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x4
	RCALL _ks0108WriteCommand
;     152 	ks0108WriteCommand(LCD_DISP_START, CHIP2);
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x8
;     153 	ks0108Fill(CLEAR);								// display clear
	RCALL SUBOPT_0x4
	RCALL _ks0108Fill
;     154 	ks0108GotoXY(0,0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _ks0108GotoXY
;     155 }
	RET
;     156 
;     157 void ks0108SetDot(unsigned char x, unsigned char y) {
;     158 	unsigned char data;
;     159 	
;     160 	ks0108GotoXY(x, y-y%8);							// read data from display memory
;	x -> Y+2
;	y -> Y+1
;	data -> R16
;     161 	data = ks0108ReadData(NO_INCREMENT_X);			// dummy read
;     162 	data = ks0108ReadData(NO_INCREMENT_X);			// "real" read
;     163 	
;     164 	data |= 0x01 << (y%8);							// set dot
;     165 	
;     166 	ks0108WriteData(data);							// write data back to display
;     167 }
;     168 
;     169 void ks0108ClearDot(unsigned char x, unsigned char y) {
;     170 	unsigned char data;
;     171 	
;     172 	ks0108GotoXY(x, y-y%8);							// read data from display memory
;	x -> Y+2
;	y -> Y+1
;	data -> R16
;     173 	data = ks0108ReadData(NO_INCREMENT_X);			// dummy read
;     174 	data = ks0108ReadData(NO_INCREMENT_X);			// "real" read
;     175 	
;     176 	data &= ~(0x01 << (y%8));						// clear dot
;     177 	
;     178 	ks0108WriteData(data);							// write data back to display
;     179 }
;     180 
;     181 
;     182 void ks0108PutChar(char c, struct font font) {
_ks0108PutChar:
;     183 	unsigned int index;
;     184 	unsigned int pages, tmp, i, j, xPos, yPos;
;     185 	
;     186 	if(c == '\n')
	SBIW R28,8
	RCALL __SAVELOCR6
;	c -> Y+18
;	font -> Y+14
;	index -> R16,R17
;	pages -> R18,R19
;	tmp -> R20,R21
;	i -> Y+12
;	j -> Y+10
;	xPos -> Y+8
;	yPos -> Y+6
	LDD  R26,Y+18
	CPI  R26,LOW(0xA)
	BRNE _0x1C
;     187 		ks0108NewLine(font.height, 0);
	LDD  R30,Y+15
	ST   -Y,R30
	RCALL SUBOPT_0x4
	RCALL _ks0108NewLine
;     188 	if(c < 32)										// ignore escape characters
_0x1C:
	LDD  R26,Y+18
	CPI  R26,LOW(0x20)
	BRSH _0x1D
;     189 		return;
	RCALL SUBOPT_0xB
	RET
;     190 	
;     191 	xPos = pos.x;									// save old coordinates
_0x1D:
	LDS  R30,_pos
	LDI  R31,0
	STD  Y+8,R30
	STD  Y+8+1,R31
;     192 	yPos = pos.y;
	__GETB1MN _pos,1
	LDI  R31,0
	STD  Y+6,R30
	STD  Y+6+1,R31
;     193 	                                        
;     194 	c -= 32;
	LDD  R30,Y+18
	SUBI R30,LOW(32)
	STD  Y+18,R30
;     195 	pages = font.height/8;							// calculate pages
	LDD  R30,Y+15
	RCALL __LSRB3
	LDI  R31,0
	__PUTW1R 18,19
;     196 	if(font.height%8 != 0)
	LDD  R30,Y+15
	ANDI R30,LOW(0x7)
	BREQ _0x1E
;     197 		pages++;
	__ADDWRN 18,19,1
;     198 	
;     199 	index = c*font.width*pages;						// get the needed array index
_0x1E:
	LDD  R30,Y+14
	LDD  R26,Y+18
	MUL  R30,R26
	MOV  R30,R0
	MOV  R26,R30
	__GETW1R 18,19
	RCALL SUBOPT_0xC
	__PUTW1R 16,17
;     200 
;     201 	for(j=0; j<pages; j++) {
	LDI  R30,0
	STD  Y+10,R30
	STD  Y+10+1,R30
_0x20:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R18
	CPC  R27,R19
	BRLO PC+2
	RJMP _0x21
;     202 		for(i=j; i<font.width*pages; i+=pages) {
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	STD  Y+12,R30
	STD  Y+12+1,R31
_0x23:
	__GETW1R 18,19
	LDD  R26,Y+14
	RCALL SUBOPT_0xC
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CP   R26,R30
	CPC  R27,R31
	BRLO PC+2
	RJMP _0x24
;     203 			tmp = font.charData[(unsigned int)index+i-1];
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADD  R30,R16
	ADC  R31,R17
	SBIW R30,1
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	LDI  R31,0
	__PUTW1R 20,21
;     204 			#asm
;     205 				nop
				nop
;     206 				nop
				nop
;     207 				nop
				nop
;     208 			#endasm

;     209 			ks0108WriteData(tmp);					// write Character-Data
	__GETW1R 20,21
	RCALL SUBOPT_0x6
;     210 		}
	__GETW1R 18,19
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+12,R30
	STD  Y+12+1,R31
	RJMP _0x23
_0x24:
;     211 		ks0108GotoXY(xPos, pos.y+8);
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R30
	__GETB1MN _pos,1
	RCALL SUBOPT_0xD
;     212 	}                                                                              
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x20
_0x21:
;     213 	ks0108GotoXY(pos.x+font.width, yPos);			// go to the upper right corner
	LDD  R30,Y+14
	LDS  R26,_pos
	ADD  R30,R26
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	RCALL SUBOPT_0x5
;     214 }
	RCALL SUBOPT_0xB
	RET
;     215 
;     216 void ks0108NewLine(unsigned char fontHeight, unsigned char offset) {
_ks0108NewLine:
;     217 	if(pos.y+fontHeight < 64)
	__GETB1MN _pos,1
	LDD  R26,Y+1
	ADD  R26,R30
	CPI  R26,LOW(0x40)
	BRSH _0x25
;     218 		ks0108GotoXY(offset, pos.y+fontHeight);
	RCALL SUBOPT_0xE
	__GETB1MN _pos,1
	LDD  R26,Y+2
	ADD  R30,R26
	RJMP _0x49
;     219 	else
_0x25:
;     220 		ks0108GotoXY(offset, 0);
	RCALL SUBOPT_0xE
	LDI  R30,LOW(0)
_0x49:
	ST   -Y,R30
	RCALL _ks0108GotoXY
;     221 }
	ADIW R28,2
	RET
;     222 
;     223 
;     224 void ks0108PutString(char *string, struct font font) {
;     225 	unsigned char startx, i=0;
;     226 	char c;
;     227 	
;     228 	startx = pos.x;
;	*string -> Y+7
;	font -> Y+3
;	startx -> R16
;	i -> R17
;	c -> R18
;     229 	c = string[0]; 
;     230 	
;     231 	while(c != 0) {
;     232 		if(c == '\n')
;     233 			ks0108NewLine(font.height, startx);
;     234 		else
;     235 			ks0108PutChar(c, font);
;     236 		c = string[++i];
;     237 	}
;     238 }
;     239 
;     240 void ks0108PutStringP(char flash *string, struct font font) {
_ks0108PutStringP:
;     241 	unsigned char startx;
;     242 	unsigned char i;
;     243 	char c;
;     244 	c = string[0];   
	RCALL __SAVELOCR3
;	*string -> Y+7
;	font -> Y+3
;	startx -> R16
;	i -> R17
;	c -> R18
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	LPM  R18,Z
;     245 	i = 0;
	LDI  R17,LOW(0)
;     246 
;     247 	
;     248 	startx = pos.x;
	LDS  R16,_pos
;     249 	
;     250 	while(c != 0) {
_0x2C:
	CPI  R18,0
	BREQ _0x2E
;     251 		if(c == '\n')
	CPI  R18,10
	BRNE _0x2F
;     252 			ks0108NewLine(font.height, startx);
	LDD  R30,Y+4
	ST   -Y,R30
	ST   -Y,R16
	RCALL _ks0108NewLine
;     253 		else
	RJMP _0x30
_0x2F:
;     254 			ks0108PutChar(c, font);
	ST   -Y,R18
	MOVW R30,R28
	ADIW R30,4
	LDI  R26,4
	RCALL __PUTPARL
	RCALL _ks0108PutChar
_0x30:
;     255 		
;     256 		c = string[i];
	MOV  R30,R17
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R18,Z
;     257 		i++;
	SUBI R17,-1
;     258 	}
	RJMP _0x2C
_0x2E:
;     259 }
	RCALL __LOADLOCR3
	ADIW R28,9
	RET
;     260 
;     261 
;     262 void ks0108SetInverted(unsigned char invert) {
;     263 	inverted = invert;
;     264 }
;     265 
;     266 char ks0108ReadData(unsigned char incXAdd) {
_ks0108ReadData:
;     267 	unsigned char data;
;     268 	volatile unsigned char i;
;     269 	
;     270 	LCD_DATA_OUT = 0x00;
	SBIW R28,1
	ST   -Y,R16
;	incXAdd -> Y+2
;	data -> R16
;	i -> Y+1
	RCALL SUBOPT_0xF
;     271 	LCD_DATA_DIR = 0x00;							// data port is input
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;     272 	
;     273 	if(pos.x < 64) {
	RCALL SUBOPT_0x10
	BRSH _0x31
;     274 		LCD_CMD_PORT &= ~(0x01 << CSEL2);			// deselect chip 2
	CBI  0x12,4
;     275 		LCD_CMD_PORT |= 0x01 << CSEL1;				// select chip 1
	SBI  0x12,3
;     276 	} else if(pos.x >= 64) {
	RJMP _0x32
_0x31:
	RCALL SUBOPT_0x10
	BRLO _0x33
;     277 		LCD_CMD_PORT &= ~(0x01 << CSEL1);			// deselect chip 1
	CBI  0x12,3
;     278 		LCD_CMD_PORT |= 0x01 << CSEL2;				// select chip 2
	SBI  0x12,4
;     279 	}
;     280 	if(pos.x == 64)									// chip2 X-address = 0
_0x33:
_0x32:
	RCALL SUBOPT_0x10
	BRNE _0x34
;     281 		ks0108WriteCommand(LCD_SET_ADD, CHIP2);
	RCALL SUBOPT_0x11
;     282 	
;     283 	LCD_CMD_PORT |= 0x01 << D_I;					// D/I = 1
_0x34:
	SBI  0x12,0
;     284 	LCD_CMD_PORT |= 0x01 << R_W;					// R/W = 1
	SBI  0x12,1
;     285 	
;     286 	
;     287 	LCD_CMD_PORT |= 0x01 << EN;						// EN high level width: min. 450ns
	SBI  0x12,2
;     288 	
;     289 	#asm
;     290 		nop
		nop
;     291 		nop
		nop
;     292 		nop
		nop
;     293 		nop
		nop
;     294 		nop
		nop
;     295 		nop
		nop
;     296 	#endasm

;     297 	
;     298 	data = LCD_DATA_IN;								// read Data			 
	IN   R16,25
;     299 	
;     300 	LCD_CMD_PORT &= ~(0x01 << EN);
	CBI  0x12,2
;     301 	for(i=0; i<16; i++);								// a little delay loop (faster than reading the busy flag)
	LDI  R30,LOW(0)
	STD  Y+1,R30
_0x36:
	LDD  R26,Y+1
	CPI  R26,LOW(0x10)
	BRSH _0x37
	LDD  R30,Y+1
	SUBI R30,-LOW(1)
	STD  Y+1,R30
	RJMP _0x36
_0x37:
;     302 	
;     303 	LCD_DATA_DIR = 0xFF;
	RCALL SUBOPT_0x12
;     304 	
;     305 	
;     306 	if(incXAdd == INCREMENT_X)						// display x-address is incremented automatically
	LDD  R30,Y+2
	CPI  R30,0
	BRNE _0x38
;     307 		pos.x++;
	RCALL SUBOPT_0x13
;     308 	else
	RJMP _0x39
_0x38:
;     309 		ks0108GotoXY(pos.x, pos.y);
	RCALL SUBOPT_0x14
	__GETB1MN _pos,1
	RCALL SUBOPT_0x5
_0x39:
;     310 	
;     311 	if(inverted)
	TST  R4
	BREQ _0x3A
;     312 		data = ~data;
	COM  R16
;     313 	return data;
_0x3A:
	MOV  R30,R16
	LDD  R16,Y+0
	ADIW R28,3
	RET
;     314 }
;     315 
;     316 void ks0108WriteCommand(unsigned char cmd, unsigned char chip) {
_ks0108WriteCommand:
;     317 	if(chip == CHIP1) {
	LD   R30,Y
	CPI  R30,0
	BRNE _0x3B
;     318 		LCD_CMD_PORT &= ~(0x01 << CSEL2);			// deselect chip 2
	CBI  0x12,4
;     319 		LCD_CMD_PORT |= 0x01 << CSEL1;				// select chip 1
	SBI  0x12,3
;     320 	} else if(chip == CHIP2) {
	RJMP _0x3C
_0x3B:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x3D
;     321 		LCD_CMD_PORT &= ~(0x01 << CSEL1);			// deselect chip 1
	CBI  0x12,3
;     322 		LCD_CMD_PORT |= 0x01 << CSEL2;				// select chip 2
	SBI  0x12,4
;     323 	}
;     324 	
;     325 	LCD_CMD_PORT &= ~(0x01 << D_I);					// D/I = 0
_0x3D:
_0x3C:
	CBI  0x12,0
;     326 	LCD_CMD_PORT &= ~(0x01 << R_W);					// R/W = 0
	CBI  0x12,1
;     327 	LCD_DATA_DIR = 0xFF;							// data port is output
	RCALL SUBOPT_0x12
;     328 	LCD_DATA_OUT = cmd;								// write command
	LDD  R30,Y+1
	RCALL SUBOPT_0x15
;     329 	ks0108Enable();									// enable
;     330 	LCD_DATA_OUT = 0x00;
	RCALL SUBOPT_0xF
;     331 }
	ADIW R28,2
	RET
;     332 
;     333 void ks0108WriteData(unsigned char data) {
_ks0108WriteData:
;     334 	unsigned char displayData, yOffset, cmdPort;
;     335 
;     336 	if(pos.x >= 128)
	RCALL __SAVELOCR3
;	data -> Y+3
;	displayData -> R16
;	yOffset -> R17
;	cmdPort -> R18
	LDS  R26,_pos
	CPI  R26,LOW(0x80)
	BRLO _0x3E
;     337 		return;
	RJMP _0x48
;     338 
;     339 	if(pos.x < 64) {
_0x3E:
	RCALL SUBOPT_0x10
	BRSH _0x3F
;     340 		LCD_CMD_PORT &= ~(0x01 << CSEL2);			// deselect chip 2
	CBI  0x12,4
;     341 		LCD_CMD_PORT |= 0x01 << CSEL1;				// select chip 1
	SBI  0x12,3
;     342 	} else if(pos.x >= 64) {
	RJMP _0x40
_0x3F:
	RCALL SUBOPT_0x10
	BRLO _0x41
;     343 		LCD_CMD_PORT &= ~(0x01 << CSEL1);			// deselect chip 1
	CBI  0x12,3
;     344 		LCD_CMD_PORT |= 0x01 << CSEL2;				// select chip 2
	SBI  0x12,4
;     345 	}
;     346 	if(pos.x == 64)									// chip2 X-address = 0
_0x41:
_0x40:
	RCALL SUBOPT_0x10
	BRNE _0x42
;     347 		ks0108WriteCommand(LCD_SET_ADD, CHIP2);
	RCALL SUBOPT_0x11
;     348 	
;     349 	LCD_CMD_PORT |= 0x01 << D_I;					// D/I = 1
_0x42:
	SBI  0x12,0
;     350 	LCD_CMD_PORT &= ~(0x01 << R_W);					// R/W = 0
	CBI  0x12,1
;     351 	LCD_DATA_DIR = 0xFF;							// data port is output
	RCALL SUBOPT_0x12
;     352 	
;     353 	
;     354 	yOffset = pos.y%8;
	__GETB1MN _pos,1
	ANDI R30,LOW(0x7)
	MOV  R17,R30
;     355 	if(yOffset != 0) {
	CPI  R17,0
	BREQ _0x43
;     356 		// first page
;     357 		cmdPort = LCD_CMD_PORT;						// save command port
	IN   R18,18
;     358 		displayData = ks0108ReadData(NO_INCREMENT_X);	// dummy read
	RCALL SUBOPT_0x16
;     359 		displayData = ks0108ReadData(NO_INCREMENT_X);	// "real" read
	RCALL SUBOPT_0x16
;     360 		
;     361 		LCD_CMD_PORT = cmdPort;						// restore command port
	OUT  0x12,R18
;     362 		LCD_DATA_DIR = 0xFF;						// data port is output
	RCALL SUBOPT_0x12
;     363 		
;     364 		displayData |= data << yOffset;
	MOV  R30,R17
	LDD  R26,Y+3
	RCALL __LSLB12
	OR   R16,R30
;     365 		if(inverted)
	TST  R4
	BREQ _0x44
;     366 			displayData = ~displayData;
	COM  R16
;     367 		LCD_DATA_OUT = displayData;					// write data
_0x44:
	OUT  0x1B,R16
;     368 		ks0108Enable();								// enable
	RCALL _ks0108Enable
;     369 		
;     370 		// second page
;     371 		ks0108GotoXY(pos.x, pos.y+8);
	RCALL SUBOPT_0x14
	__GETB1MN _pos,1
	RCALL SUBOPT_0xD
;     372 		
;     373 		displayData = ks0108ReadData(NO_INCREMENT_X);	// dummy read
	RCALL SUBOPT_0x16
;     374 		displayData = ks0108ReadData(NO_INCREMENT_X);	// "real" read
	RCALL SUBOPT_0x16
;     375 		
;     376 		LCD_CMD_PORT = cmdPort;						// restore command port
	OUT  0x12,R18
;     377 		LCD_DATA_DIR = 0xFF;						// data port is output
	RCALL SUBOPT_0x12
;     378 		
;     379 		displayData |= data >> (8-yOffset);
	LDI  R30,LOW(8)
	SUB  R30,R17
	LDD  R26,Y+3
	RCALL __LSRB12
	OR   R16,R30
;     380 		if(inverted)
	TST  R4
	BREQ _0x45
;     381 			displayData = ~displayData;
	COM  R16
;     382 		LCD_DATA_OUT = displayData;					// write data
_0x45:
	OUT  0x1B,R16
;     383 		ks0108Enable();								// enable
	RCALL _ks0108Enable
;     384 		
;     385 		ks0108GotoXY(pos.x+1, pos.y-8);
	LDS  R30,_pos
	SUBI R30,-LOW(1)
	ST   -Y,R30
	__GETB2MN _pos,1
	SUBI R26,LOW(8)
	ST   -Y,R26
	RCALL _ks0108GotoXY
;     386 	} else {
	RJMP _0x46
_0x43:
;     387 		if(inverted)
	TST  R4
	BREQ _0x47
;     388 			data = ~data;
	LDD  R30,Y+3
	COM  R30
	STD  Y+3,R30
;     389 		LCD_DATA_OUT = data;						// write data
_0x47:
	LDD  R30,Y+3
	RCALL SUBOPT_0x15
;     390 		ks0108Enable();								// enable
;     391 		pos.x++;
	RCALL SUBOPT_0x13
;     392 	}
_0x46:
;     393 	LCD_DATA_OUT = 0x00;
	RCALL SUBOPT_0xF
;     394 }
_0x48:
	RCALL __LOADLOCR3
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(255)
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x5:
	ST   -Y,R30
	RJMP _ks0108GotoXY

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x6:
	ST   -Y,R30
	RJMP _ks0108WriteData

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	MOV  R17,R30
	ST   -Y,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x8:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _ks0108WriteCommand

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(63)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	LDI  R30,LOW(192)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	RCALL __LOADLOCR6
	ADIW R28,19
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	LDI  R27,0
	RCALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	SUBI R30,-LOW(8)
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	LD   R30,Y
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x10:
	LDS  R26,_pos
	CPI  R26,LOW(0x40)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LDI  R30,LOW(64)
	ST   -Y,R30
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x12:
	LDI  R30,LOW(255)
	OUT  0x1A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	LDI  R26,LOW(_pos)
	LDI  R27,HIGH(_pos)
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	LDS  R30,_pos
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x15:
	OUT  0x1B,R30
	RJMP _ks0108Enable

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x16:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _ks0108ReadData
	MOV  R16,R30
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSRB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSRB12R
__LSRB12L:
	LSR  R30
	DEC  R0
	BRNE __LSRB12L
__LSRB12R:
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__PUTPARL:
	CLR  R27
__PUTPAR:
	ADD  R30,R26
	ADC  R31,R27
__PUTPAR0:
	LD   R0,-Z
	ST   -Y,R0
	SBIW R26,1
	BRNE __PUTPAR0
	RET

__LSLB3:
	LSL  R30
	LSL  R30
	LSL  R30
	RET

__LSRB3:
	LSR  R30
	LSR  R30
	LSR  R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

