// Used C
#include <mega8535.h>

// LCD Specific
#include "ks0108.h"
#include "font6x8.h"
#include "pics.h"
//#include "font12x16.h"
#include <delay.h>

void main(void) {          
	struct font smallFont, largeFont;
	unsigned char i,j;
	
	DDRB=0xFF;
	PORTB=0xFF;
	
	DDRC=0x00;
	PORTC=0xFF;
	
	delay_ms(2000);
	          
	smallFont.width = FONT6X8_WIDTH;
	smallFont.height = FONT6X8_HEIGHT;
	smallFont.charData = Font6x8;
	//smallFont.width = FONT12X16_WIDTH;
	//smallFont.height = FONT12X16_HEIGHT;
	//smallFont.charData = Font12x16;
	
	ks0108Init();
	


   /*	PORTB=0x00;
		delay_ms(1000);
		PORTB=0xFF;
		delay_ms(1000);


	ks0108GotoXY(0,0);
	for(i=0;i<64;i++)
	{                     
	    ks0108SetDot(i,i);
	}                   
	for(i=64;i<128;i++)
	{
		ks0108SetDot(i,i-64);
	}


	PORTB=0x00;
		delay_ms(1000);
		PORTB=0xFF;
		delay_ms(1000); */
                        
		
    ks0108GotoXY(2,2);
    ks0108PutStringP("Teststring 0\n Testring 1\n Testring 2\n",smallFont);
    
    while(PINC.0 == 1)
    		;
    
    ks0108Picture(bsj);
		
	while(1)
	{  
	  	PORTB=0x00;
		delay_ms(200);
		PORTB=0xFF;
		delay_ms(200);
	}
}
// Used C
#include <mega8535.h>

// LCD Specific
#include "ks0108.h"

struct displayPos pos;
unsigned char inverted=0;

void ks0108Picture(flash unsigned char* pic)
{
	unsigned int i,j;
		
	for(i=0;i<8;i++)
	{
		ks0108GotoXY(0,i*8);
		for(j=0; j<128; j++)
			ks0108WriteData(pic[(i*128)+j]);
	}
}

void ks0108Enable(void) {
	volatile unsigned char i;
	
	LCD_CMD_PORT |= 0x01 << EN;						// EN high level width: min. 450ns
	#asm
		nop
		nop
		nop
		nop
		nop
		nop
	#endasm
	LCD_CMD_PORT &= ~(0x01 << EN);
	for(i=0; i<16; i++);								// a little delay loop (faster than reading the busy flag)
}

void ks0108Fill(unsigned char mode) {
	unsigned char i, j;
	
	for(i=0; i<8; i++) {							// page address
		ks0108GotoXY(0, i*8);
		for(j=0; j<128; j++)						// x address
			ks0108WriteData(mode);					// write data
	}
}

void ks0108GotoXY(unsigned char x, unsigned char y) {
	unsigned char chip = CHIP1, cmd;
	
	if(x > 127) x = 0;								// ensure that coordinates are legal
	if(y > 63)  y = 0;
	
	pos.x = x;										// save new coordinates
	pos.y = y;
	pos.page = y/8;
	
	if(x >= 64) {									// select the right chip
		x -= 64;
		chip = CHIP2;
	}
	cmd = LCD_SET_ADD | x;
	ks0108WriteCommand(cmd, chip);					// set x address on active chip
	
	cmd = LCD_SET_PAGE | pos.page;					// set y address on both chips
	ks0108WriteCommand(cmd, CHIP1);
	ks0108WriteCommand(cmd, CHIP2);
}

void ks0108Init(void) {
	pos.x = 0;
	pos.y = 0;
	pos.page = 0;
	
	LCD_CMD_DIR = 0xFF;								// command port is output
	ks0108WriteCommand(LCD_ON, CHIP1);				// power on
	ks0108WriteCommand(LCD_ON, CHIP2);
	
	ks0108WriteCommand(LCD_DISP_START, CHIP1);		// display start line = 0
	ks0108WriteCommand(LCD_DISP_START, CHIP2);
	ks0108Fill(CLEAR);								// display clear
	ks0108GotoXY(0,0);
}

void ks0108SetDot(unsigned char x, unsigned char y) {
	unsigned char data;
	
	ks0108GotoXY(x, y-y%8);							// read data from display memory
	data = ks0108ReadData(NO_INCREMENT_X);			// dummy read
	data = ks0108ReadData(NO_INCREMENT_X);			// "real" read
	
	data |= 0x01 << (y%8);							// set dot
	
	ks0108WriteData(data);							// write data back to display
}

void ks0108ClearDot(unsigned char x, unsigned char y) {
	unsigned char data;
	
	ks0108GotoXY(x, y-y%8);							// read data from display memory
	data = ks0108ReadData(NO_INCREMENT_X);			// dummy read
	data = ks0108ReadData(NO_INCREMENT_X);			// "real" read
	
	data &= ~(0x01 << (y%8));						// clear dot
	
	ks0108WriteData(data);							// write data back to display
}


void ks0108PutChar(char c, struct font font) {
	unsigned int index;
	unsigned int pages, tmp, i, j, xPos, yPos;
	
	if(c == '\n')
		ks0108NewLine(font.height, 0);
	if(c < 32)										// ignore escape characters
		return;
	
	xPos = pos.x;									// save old coordinates
	yPos = pos.y;
	                                        
	c -= 32;
	pages = font.height/8;							// calculate pages
	if(font.height%8 != 0)
		pages++;
	
	index = c*font.width*pages;						// get the needed array index

	for(j=0; j<pages; j++) {
		for(i=j; i<font.width*pages; i+=pages) {
			tmp = font.charData[(unsigned int)index+i-1];
			#asm
				nop
				nop
				nop
			#endasm
			ks0108WriteData(tmp);					// write Character-Data
		}
		ks0108GotoXY(xPos, pos.y+8);
	}                                                                              
	ks0108GotoXY(pos.x+font.width, yPos);			// go to the upper right corner
}

void ks0108NewLine(unsigned char fontHeight, unsigned char offset) {
	if(pos.y+fontHeight < 64)
		ks0108GotoXY(offset, pos.y+fontHeight);
	else
		ks0108GotoXY(offset, 0);
}


void ks0108PutString(char *string, struct font font) {
	unsigned char startx, i=0;
	char c;
	
	startx = pos.x;
	c = string[0]; 
	
	while(c != 0) {
		if(c == '\n')
			ks0108NewLine(font.height, startx);
		else
			ks0108PutChar(c, font);
		c = string[++i];
	}
}

void ks0108PutStringP(char flash *string, struct font font) {
	unsigned char startx;
	unsigned char i;
	char c;
	c = string[0];   
	i = 0;

	
	startx = pos.x;
	
	while(c != 0) {
		if(c == '\n')
			ks0108NewLine(font.height, startx);
		else
			ks0108PutChar(c, font);
		
		c = string[i];
		i++;
	}
}


void ks0108SetInverted(unsigned char invert) {
	inverted = invert;
}

char ks0108ReadData(unsigned char incXAdd) {
	unsigned char data;
	volatile unsigned char i;
	
	LCD_DATA_OUT = 0x00;
	LCD_DATA_DIR = 0x00;							// data port is input
	
	if(pos.x < 64) {
		LCD_CMD_PORT &= ~(0x01 << CSEL2);			// deselect chip 2
		LCD_CMD_PORT |= 0x01 << CSEL1;				// select chip 1
	} else if(pos.x >= 64) {
		LCD_CMD_PORT &= ~(0x01 << CSEL1);			// deselect chip 1
		LCD_CMD_PORT |= 0x01 << CSEL2;				// select chip 2
	}
	if(pos.x == 64)									// chip2 X-address = 0
		ks0108WriteCommand(LCD_SET_ADD, CHIP2);
	
	LCD_CMD_PORT |= 0x01 << D_I;					// D/I = 1
	LCD_CMD_PORT |= 0x01 << R_W;					// R/W = 1
	
	
	LCD_CMD_PORT |= 0x01 << EN;						// EN high level width: min. 450ns
	
	#asm
		nop
		nop
		nop
		nop
		nop
		nop
	#endasm
	
	data = LCD_DATA_IN;								// read Data			 
	
	LCD_CMD_PORT &= ~(0x01 << EN);
	for(i=0; i<16; i++);								// a little delay loop (faster than reading the busy flag)
	
	LCD_DATA_DIR = 0xFF;
	
	
	if(incXAdd == INCREMENT_X)						// display x-address is incremented automatically
		pos.x++;
	else
		ks0108GotoXY(pos.x, pos.y);
	
	if(inverted)
		data = ~data;
	return data;
}

void ks0108WriteCommand(unsigned char cmd, unsigned char chip) {
	if(chip == CHIP1) {
		LCD_CMD_PORT &= ~(0x01 << CSEL2);			// deselect chip 2
		LCD_CMD_PORT |= 0x01 << CSEL1;				// select chip 1
	} else if(chip == CHIP2) {
		LCD_CMD_PORT &= ~(0x01 << CSEL1);			// deselect chip 1
		LCD_CMD_PORT |= 0x01 << CSEL2;				// select chip 2
	}
	
	LCD_CMD_PORT &= ~(0x01 << D_I);					// D/I = 0
	LCD_CMD_PORT &= ~(0x01 << R_W);					// R/W = 0
	LCD_DATA_DIR = 0xFF;							// data port is output
	LCD_DATA_OUT = cmd;								// write command
	ks0108Enable();									// enable
	LCD_DATA_OUT = 0x00;
}

void ks0108WriteData(unsigned char data) {
	unsigned char displayData, yOffset, cmdPort;

	if(pos.x >= 128)
		return;

	if(pos.x < 64) {
		LCD_CMD_PORT &= ~(0x01 << CSEL2);			// deselect chip 2
		LCD_CMD_PORT |= 0x01 << CSEL1;				// select chip 1
	} else if(pos.x >= 64) {
		LCD_CMD_PORT &= ~(0x01 << CSEL1);			// deselect chip 1
		LCD_CMD_PORT |= 0x01 << CSEL2;				// select chip 2
	}
	if(pos.x == 64)									// chip2 X-address = 0
		ks0108WriteCommand(LCD_SET_ADD, CHIP2);
	
	LCD_CMD_PORT |= 0x01 << D_I;					// D/I = 1
	LCD_CMD_PORT &= ~(0x01 << R_W);					// R/W = 0
	LCD_DATA_DIR = 0xFF;							// data port is output
	
	
	yOffset = pos.y%8;
	if(yOffset != 0) {
		// first page
		cmdPort = LCD_CMD_PORT;						// save command port
		displayData = ks0108ReadData(NO_INCREMENT_X);	// dummy read
		displayData = ks0108ReadData(NO_INCREMENT_X);	// "real" read
		
		LCD_CMD_PORT = cmdPort;						// restore command port
		LCD_DATA_DIR = 0xFF;						// data port is output
		
		displayData |= data << yOffset;
		if(inverted)
			displayData = ~displayData;
		LCD_DATA_OUT = displayData;					// write data
		ks0108Enable();								// enable
		
		// second page
		ks0108GotoXY(pos.x, pos.y+8);
		
		displayData = ks0108ReadData(NO_INCREMENT_X);	// dummy read
		displayData = ks0108ReadData(NO_INCREMENT_X);	// "real" read
		
		LCD_CMD_PORT = cmdPort;						// restore command port
		LCD_DATA_DIR = 0xFF;						// data port is output
		
		displayData |= data >> (8-yOffset);
		if(inverted)
			displayData = ~displayData;
		LCD_DATA_OUT = displayData;					// write data
		ks0108Enable();								// enable
		
		ks0108GotoXY(pos.x+1, pos.y-8);
	} else {
		if(inverted)
			data = ~data;
		LCD_DATA_OUT = data;						// write data
		ks0108Enable();								// enable
		pos.x++;
	}
	LCD_DATA_OUT = 0x00;
}
